if(!isObject($Swol_FriendList))
{
	$Swol_FriendList = new ScriptObject(Swol_FriendList)
	{
		guiObj = FriendGui;
		guiAddObj = FriendAddGui;
		guiButtonObj = Swol_GuiObj_FriendAddBtn;
		guiWindow = Swol_GuiObj_FriendWindow;
		guiAddWindow = Swol_GuiObj_FriendAddWindow;
		blidObj = Swol_GuiObj_FriendBLID;
		listObj = Swol_GuiObj_FriendList;
		count = 0;
		friendPrefix = "<bitmap:add-ons/client_friendlist/friend>";
	};
}
package swol_friendlist
{
	function nameToBLID(%name)
	{
		%cnt = npl_list.rowCount();
		for(%i=0;%i<%cnt;%i++)
		{
			%row = npl_list.getrowtext(%i);
			if(getfield(%row,1) $= %name)
			{
				%blid = getfield(%row,3);
				return %blid;
			}
		}
		return -1;
	}
	function injectTrustListFriendList()
	{
		//fuck this button no one uses it
		NPL_Window.getObject(9).position = "600 200";
		if(isObject(Swol_GuiObj_FriendAddBtn))
		Swol_GuiObj_FriendAddBtn.delete();
		
		%a = new GuiBitmapButtonCtrl(Swol_GuiObj_FriendAddBtn) 
		{
		   profile = "BlockButtonProfile";
		   horizSizing = "left";
		   vertSizing = "bottom";
		   position = "405 284";
		   extent = "76 21";
		   minExtent = "8 2";
		   enabled = "1";
		   visible = "1";
		   clipToParent = "1";
		   command = "Swol_FriendList.addFriendFromTrustList();";
		   text = "FRIEND LIST";
		   groupNum = "-1";
		   buttonType = "PushButton";
		   bitmap = "base/client/ui/button1";
		   lockAspectRatio = "0";
		   alignLeft = "0";
		   alignTop = "0";
		   overflowImage = "0";
		   mKeepCached = "0";
		   mColor = "255 255 255 255";
		};
		NPL_Window.add(%a);
	}
	function clientCmdServerMessage(%prefix,%line,%name,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k)
	{
		if(strPos(%line,%name SPC "connected.") || strPos(%line,%name SPC "has left the game.") != -1)
		{
			if($Swol_FriendList.idExists(nameToBLID(%name)))
			{
				%identifier = getWord(%line,0);
				%line = getWords(%line,1,getWordCount(%line));
				%line = %identifier SPC $Swol_FriendList.friendPrefix SPC %line;
			}
		}
		parent::clientCmdServerMessage(%prefix,%line,%name,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k);
	}
	function clientCmdChatMessage(%cl, %voice, %pitch, %line, %pre, %name, %suf, %msg)
	{
		if($Swol_FriendList.idExists(nameToBLID(%name)))
		{
			%identifier = getWord(%line,0);
			%line = getWords(%line,1,getWordCount(%line));
			%line = %identifier SPC $Swol_FriendList.friendPrefix SPC %line;
		}
		parent::clientCmdChatMessage(%cl, %voice, %pitch, %line, %pre, %name, %suf, %msg);
	}
	function onMissionDownloadPhase1()
	{
		$Swol_FriendList.schedule(10,updateAllNames);
		parent::onMissionDownloadPhase1();
	}
	function newPlayerListGui::update(%this, %cl, %name,%blid,%a,%b,%c)
	{
		parent::update(%this, %cl, %name,%blid,%a,%b,%c);
		$Swol_FriendList.updateName(%name,%blid);
	}
	function Swol_FriendList::sortRowNum(%this,%row)
	{
		%this.listObj.sortNumerical(%row,%this.rowDir[%row]);
		%this.rowDir[%row] = !%this.rowDir[%row];
		%this.listObj.setSelectedById(%this.curSelect);
	}
	function Swol_FriendList::sortRowAlpha(%this,%row)
	{
		%this.listObj.sort(%row,%this.rowDir[%row]);
		%this.rowDir[%row] = !%this.rowDir[%row];
		%this.listObj.setSelectedById(%this.curSelect);
	}
	function Swol_FriendList::addFriendFromTrustList(%this)
	{
		%this.open();
		%this.blidObj.setValue(%this.playListSelectedBLID);
	}
	function Swol_FriendList::addFriendByBLID(%this)
	{
		%blid = %this.blidObj.getValue();
		%whitelist = "0123456789";
		for(%i=0;%i<strlen(%blid);%i++)
		{
			%char = getSubStr(%blid,%i,1);
			if(strPos(%whitelist,%char) == -1)
			continue;
			
			%new = %new @ %char;
		}
		%fail = false;
		if(%new > 1 && %new < 99)
		{
			messageBoxOk("Error","These BL_ID's are unregistered");
			%fail = true;
		}
		else if(%new == getNumKeyID())
		{
			messageBoxOk("Looking for friends?","You can't add yourself to your friend list");
			%fail = true;
		}
		else if(%new == 43420 || %new == 43421 || %new == 10103)
		{
			//fuck you, you'll always be with me
			messageBoxOk("...","RIP, you won't be missed");
			%fail = true;
		}
		%this.blidObj.setValue("");
		if(%fail)
		return;
		%this.addElement("-1",%new);
		%this.updateAllNames(%this);
		%this.closeAddBLID();
	}
	function Swol_FriendList::updateAllNames(%this)
	{
		for(%i=0;%i<npl_list.rowCount();%i++)
		{
			%row = npl_list.getRowText(%i);
			%name = getfield(%row,1);
			%blid = getfield(%row,3);
			%this.updateName(%name,%blid);
		}
		%this.lookUpNameStart();
	}
	function Swol_FriendList::updateName(%this,%name,%blid)
	{
		if(!%this.idExists(%blid))
		return;
		%id = -1;
		for(%i=0;%i<%this.count;%i++)
		{
			if(%blid == %this.blid[%i])
			%id = %i;
		}
		
		%tmpN = %name;
		%tmpB = %blid;
		%this.removeElement(%blid);
		%tmp = %this.addElement(%name,%blid);
		if(%id == %this.curSelect)
		%this.curSelect = %tmp;
		
		%this.listObj.setSelectedById(%this.curSelect);
	}
	function Swol_FriendList::addElement(%this,%name,%blid,%override)
	{
		if(%this.idExists(%blid))
		return;
		
		%this.listObj.addRow(%this.count,%name @ "\t" @ %blid,%this.count);
		%this.name[%this.count] = %name;
		%this.blid[%this.count] = %blid;
		%this.count++;
		
		if(!%override)
		%this.saveFriends();
		
		return %this.count-1;
	}
	function Swol_FriendList::removeElement(%this,%blid)
	{
		for(%i=0;%i<%this.count;%i++)
		{
			if(%blid == %this.blid[%i])
			{
				%this.listObj.removeRowById(%i);
				%this.name[%i] = "";
				%this.blid[%i] = "";
				break;
			}
		}
		%this.saveFriends();
	}
	function Swol_FriendList::removeSelected(%this)
	{
		if(%this.curSelect >= 0)
		{
			%blid = %this.getBlidFromId(%this.curSelect);
			%this.removeElement(%blid);
			%this.curSelect = -1;
		}
	}
	function Swol_FriendList::clear(%this)
	{
		%this.listObj.clear();
		%this.count = 0;
	}
	function Swol_FriendList::getBlidFromId(%this,%id)
	{
		return %this.blid[%id];
	}
	function Swol_FriendList::updateSelected(%this,%id)
	{
		%this.curSelect = %id;
	}
	function Swol_FriendList::openAddBLID(%this)
	{
		%x = getWord(%this.guiWindow.position,0);
		%y = getWord(%this.guiWindow.position,1);
		%w = getWord(%this.guiWindow.extent,0);
		%h = getWord(%this.guiWindow.extent,1);
		
		%w_a = getWord(%this.guiAddWindow.extent,0);
		%h_a = getWord(%this.guiAddWindow.extent,1);
		
		%this.guiAddWindow.position = (%x+(%w/2))-(%w_a/2) SPC (%y+(%h/2))-(%h_a/2);
		canvas.pushDialog(%this.guiAddObj);
	}
	function Swol_FriendList::closeAddBLID(%this)
	{
		canvas.popDialog(%this.guiAddObj);
		%this.blidObj.setValue("");
	}
	function Swol_FriendList::open(%this)
	{
		canvas.pushDialog(%this.guiObj);
	}
	function Swol_FriendList::close(%this)
	{
		canvas.popDialog(%this.guiObj);
	}
	function Swol_FriendList::idExists(%this,%blid)
	{
		for(%i=0;%i<%this.count;%i++)
		{
			if(%blid == %this.blid[%i])
			return true;
		}
		return false;
	}
	function Swol_FriendList::saveFriends(%this)
	{
		%fw = new fileObject();
		%fw.openForWrite("config/client/friends.txt");
		for(%i=0;%i<%this.count;%i++)
		{
			if(%this.blid[%i] !$= "")
			%fw.writeLine(%this.blid[%i] @ "\t" @ %this.name[%i]);
		}
		%fw.close();
		%fw.delete();
	}
	function Swol_FriendList::loadFriends(%this)
	{
		%fr = new fileObject();
		%fr.openForRead("config/client/friends.txt");
		while(!%fr.isEOF())
		{
			%ln = %fr.readLine();
			%blid = getField(%ln,0);
			%name = getField(%ln,1);
			%this.addElement(%name,%blid,true);
		}
		%fr.close();
		%fr.delete();
	}
	function NPL_List::getRowIdByBlid(%this,%blid)
	{
		for(%i=0;%i<npl_list.rowCount();%i++)
		{
			%row = npl_list.getRowText(%i);
			if(getfield(%row,3) == %blid)
			{
				return npl_list.getRowID(%i);
			}
		}
		return -1;
	}
	function NPL_List::onSelect(%this,%selected)
	{
		%row = %this.getRowTextById(%selected);
		%blid = getField(%row,3);
		$Swol_FriendList.playListSelectedBLID = %blid;
	}
	function Swol_GuiObj_FriendList::onSelect(%this,%selected)
	{
		$Swol_FriendList.updateSelected(%selected);
	}
	function Swol_FriendList::lookUpNameStart(%this)
	{
		%this.lookUpNamesProcedurally(0);
	}
	function Swol_FriendList::lookUpNamesProcedurally(%this,%step)
	{
		if(%step >= %this.count)
		{
			%this.saveFriends();
			return;
		}
		if(%this.blid[%step] $= "")
		{
			%step++;
			%this.lookUpNamesProcedurally(%step);
			return;
		}
		%name = %this.name[%step];
		if(%name $= "-1")
		{
			%blid = %this.blid[%step];
			%step++;
			%this.tcp_nextStep = %step;
			%this.lookUpName(%blid);
		}
		else
		{
			%step++;
			%this.lookUpNamesProcedurally(%step);
		}
	}
	function Swol_FriendList::lookUpName(%this,%blid)
	{
		connectToURL("http://stats.greek2me.us/user-lookup.php?blid=" @ %blid, "GET", "", "Swol_NameLookup");
		%this.tcp_line = 0;
		%this.tcp_blid = %blid;
	}
	function Swol_NameLookup::handleText(%this,%line)
	{
		if($Swol_FriendList.tcp_line == 1)
		{
			%name = getField(%line,1);
			if(%name !$= "")
			{
				$Swol_FriendList.updateName(%name,$Swol_FriendList.tcp_blid);
			}
			$Swol_FriendList.schedule(10,lookUpNamesProcedurally,%this.tcp_nextStep);
		}
		$Swol_FriendList.tcp_line++;
	}
};
activatePackage(swol_friendlist);
if(!isObject(Swol_FriendList.guiObj))
exec("./FriendGui.gui");
if(!isObject(Swol_FriendList.guiAddObj))
exec("./FriendAddGui.gui");
Swol_FriendList.clear();
Swol_FriendList.loadFriends();
injectTrustListFriendList();
exec("./Support_TCPClient.cs");